game = {}

game_pause = false

game_time = {c = 60, m = 60}

local first = true

function game.reset()
	if first then
		if shaders_enabled then
			note.new("Shaders  Enabled (press 'o' to toggle)")
		else
			note.new("Shaders  Disabled")
		end
		note.new("Controls: A and D or LEFT and RIGHT to move, W or SPACE to jump, LMB do shoot", 5)
		first = false
	end
	
	
	player.reset()
	obj.reset()
	coin.reset()
	
	game_time.c = game_time.m
	
end

function game.update(dt)
	if not game_pause then
		game_time.c = game_time.c - dt
		world.update(dt)
		obj.update(dt)
		coin.update(dt)
		shaders.light.update(dt)
		player.update(dt)
		note.update(dt)
		
		--Death/loss check
		if player.health.c < 0 or game_time.c < 0 then
			player.health.c = 0
			note.new("Game over. You collected $"..player.money)
			note.new("Starting New Game.")
			game.reset()
		end
	end
end

function game.draw()
	if not game_pause then
		world.draw()
		
		obj.draw()
		coin.draw()
	
		player.draw()
		note.draw()
		
		--HUD
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.setFont(font.large)
		love.graphics.print("$"..player.money, 200, 32)
		love.graphics.print("Health: "..player.health.c, 200, 64)
		love.graphics.print("Time: "..math.floor(game_time.c), 200, 96)
	end
end

function game.keypressed(key)
	if not game_pause then
		player.keypressed(key)
	end
end

function game.mousepressed(x, y, k)
	if not game_pause then
		player.mousepressed(x, y, k)
		
		if k == "r" and debug_enabled then
			obj.spawn(x, y, 2)
		end
	end
end