note = {}

notes = {}

note_x = 12
note_y = screen.h - 24
note_space = 16 --Vertical spacing
note_fs = 700 --fade speed
note_dd = 4 --Default duration
note_ss = 500 --Scroll speed

function note.new(s, d)
	local rd = note_add
	if d == nil then
		rd = note_dd
	else
		rd = d
	end
	
		--Current note update
	for i,v in ipairs(notes) do
		v.ny = v.y - note_space
	end
	
	notes[#notes + 1] = {
			x = note_x,
			y = note_y,
			ny = note_y,
			s = s,
			d = rd,
			rem = false,
			sp = false,
			a = 0
		}
end

function note.update(dt)
	for i,v in ipairs(notes) do
		if not v.sp then
			v.a = v.a + note_fs * dt
			if v.a > 255 then
				v.a = 255
				v.sp = true
			end
		end
		
		--Scroll
		v.y = v.y - note_ss * dt
		if v.y < v.ny then
			v.y = v.ny 
		end
	
			--Remove timer
			v.d = v.d - dt
			if v.d < 0 then
				v.rem = true
			end

		--Removal
		if v.rem then
			v.a = v.a - note_fs * dt
			if v.a < 0 then
				table.remove(notes, i)
			end
		end
	end
end

function note.draw()
	love.graphics.setFont(font.small)
	for i,v in ipairs(notes) do
		love.graphics.setColor(255, 255, 255, v.a)
		love.graphics.print(v.s, v.x, v.y)
	end
end